
local old_MutatorPiggyBank_update = MutatorPiggyBank.update

function MutatorPiggyBank:update(t, dt)
	old_MutatorPiggyBank_update(self, t, dt)

	if self._pig_level > 1 then
		local player_unit = managers.player:local_player()
		local current_state = managers.player:current_state()
		local invalid_states = {
			"mask_off",
			"clean",
			"civilian"
		}

		if alive(player_unit) and not managers.interaction:active_unit() and not table.contains(invalid_states, current_state) then
			local text_string, text_icon = nil
			local current_player_state = managers.player:get_current_state()
			local fwd_ray = current_player_state and current_player_state.get_fwd_ray and current_player_state:get_fwd_ray()

			if fwd_ray and table.contains(self._piggybank_units, fwd_ray.unit) then
				local progress_range = self._tweakdata.progress_range or 1000

				if fwd_ray.distance < progress_range then
					local next_pig_level_tweak = self._tweakdata.pig_levels[self._pig_level + 1]

					if next_pig_level_tweak then
						local current_count = self._pig_fed_count - self._current_pig_level_tweak.bag_requirement
						local next_count = next_pig_level_tweak.bag_requirement - self._current_pig_level_tweak.bag_requirement
						local lvl0 = self._pig_level == 2 and 1 or 0
						local macros = {
							PIGGY_PROGRESS = (current_count + lvl0) .. "/" .. (next_count + lvl0),
							PIGGY_LEVEL = tostring(self._pig_level - 1)
						}

						text_string = string.sub(managers.localization:text("hud_pda9_show_progress", macros), 1, -3) .. ")"
					end
				end
			end

			if text_string then
				managers.hud:show_interact({
					text = text_string,
					icon = text_icon
				})
			else
				managers.hud:remove_interact()
			end
		end
	end
end