local old_MutatorPiggyRevenge_u = MutatorPiggyRevenge.update

function MutatorPiggyRevenge:update(t, dt)
	old_MutatorPiggyRevenge_u(self,t,dt)

	if self._pig_level > 1 then
		local player_unit = managers.player:local_player()
		local current_state = managers.player:current_state()
		local invalid_states = {
			"mask_off",
			"clean",
			"civilian"
		}

		if alive(player_unit) and not managers.interaction:active_unit() and not table.contains(invalid_states, current_state) then
			local text_string, text_icon = nil
			local current_player_state = managers.player:get_current_state()
			local progress_range = self._tweakdata.progress_range or 1000
			local show_progress = false
			local hand_id, hand_unit = nil

			if _G.IS_VR then
				local hand_ids = player_unit:hand():interaction_ids()

				if current_player_state._interact_hand and not table.contains(hand_ids, current_player_state._interact_hand) then
					table.insert(hand_ids, current_player_state._interact_hand)
				end

				for _, id in ipairs(hand_ids) do
					hand_unit = player_unit:hand():hand_unit(id)

					if hand_unit then
						local fwd_ray = hand_unit:raycast("ray", hand_unit:position(), hand_unit:position() + hand_unit:rotation():y() * progress_range, "slot_mask", 1)

						if fwd_ray and table.contains(self._piggybank_units, fwd_ray.unit) then
							show_progress = true
							hand_id = id

							break
						end
					end
				end
			end

			if not show_progress then
				local fwd_ray = current_player_state and current_player_state.get_fwd_ray and current_player_state:get_fwd_ray()

				if fwd_ray and table.contains(self._piggybank_units, fwd_ray.unit) then
					show_progress = fwd_ray.distance < progress_range
				end
			end

			if show_progress then
				local next_pig_level_tweak = self._tweakdata.pig_levels[self._pig_level + 1]

				if next_pig_level_tweak then
					local current_count = self._pig_fed_count - self._current_pig_level_tweak.bag_requirement
					local next_count = next_pig_level_tweak.bag_requirement - self._current_pig_level_tweak.bag_requirement
					local lvl0 = self._pig_level == 2 and 1 or 0
					local macros = {
						PIGGY_PROGRESS = (current_count + lvl0) .. "/" .. (next_count + lvl0),
						PIGGY_LEVEL = tostring(self._pig_level - 1)
					}

					text_string = string.sub(managers.localization:text("hud_pda9_show_progress", macros), 1, -3) .. ")"
				end
			end

			if text_string then
				managers.hud:show_interact({
					text = text_string,
					icon = text_icon
				})

				if _G.IS_VR then
					managers.hud:link_watch_prompt(hand_unit, hand_id)
					managers.hud:watch_prompt_panel():show()
				end
			else
				managers.hud:remove_interact()
			end
		end
	end
end